% 
% Written by:
% -- 
% John L. Weatherwax                2005-11-12
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

[ N, D, Xs_big, k_big, Jp, Pc, Aw, mw ] = readLandSat( 'trn' );
[ N, D, Xs_sml, k_sml, Jp_sml, Pc ] = readLandSat( 'trn', 1500 );

dArray = [ 3 4 9 15 36 ]; 
%dArray = [ 2 ]; 
for di=1:length(dArray),
  d=dArray(di); 

  [ W0, Ws, Is ] = MMI_Max_With_Diff_Inits(d,...
					   Xs_big,k_big,...
					   Xs_sml,k_sml,Jp_sml);
  Xs = Xs_big; 			     
  Ys = Xs * W0; 
  k = k_big; 
  % Save the projection at this stage:
  save( [ 'mmi_projection_d_',num2str(d),'.mat' ] );
  
  if( 0 )
    % Plot the results: 
    cs = { 'yo', 'g*', 'bd', 'rs', 'bx', 'm+' }; 
    figure; 
    for i=1:length(unique(k))
      inds=find(k==i);
      plot( -Ys(inds,1), Ys(inds,2), cs{i} ); 
      if( i==1 ) hold on; end
    end
    axis( [ -3.5 3.5 -3.5 3.5 ] ); grid on; drawnow; 
    title( 'Final Projected LandSat Data' ); 
  end

  dataStr = 'LandSat'; methStr = 'MMI'; tst_OR_trn = 'trn'; 
  writeLVQInput(dataStr,methStr,tst_OR_trn,Xs,Ys,k);

  % Generate testing data: 
  %
  [ N, D, Xs, k, Jp, Pc ] = readLandSat( 'tst' );
  Xs_tst = ( Aw * ( Xs.' - repmat(mw,1,size(Xs,1)) ) ).'; 
  Ys_tst = Xs_tst * W0; 
  dataStr = 'LandSat'; methStr = 'MMI'; tst_OR_trn = 'tst'; 
  writeLVQInput(dataStr,methStr,tst_OR_trn,Xs_tst,Ys_tst,k);
end

