function [patterns, W, m] = PCA(patterns)

%Reshape the data points using the principal component analysis
%Inputs:
%	patterns	- Input patterns
%
%Outputs
%	patterns        - New patterns
%	W               - Reshape martix
%       m               - Original pattern averages

[r,c] = size(patterns);

%Calculate cov matrix and the PCA matrixes
m           = mean(patterns')';
S           = ((patterns - m*ones(1,c)) * (patterns - m*ones(1,c))');
[V, D]	    = eig(S);

% Further orthogonalize the columns of V:
Q = gram(V); V = Q; 

% Extract and sort the eigenvalues in decending order:
[sDum,iSort] = sort(-diag(D));

% Extract eigenvectors with largest eigenvalues:
W = V(:,iSort);

%Calculate new patterns
patterns = (W.') * patterns;
